#define KP 7
#define SPEED 50

#define MIN_SPEED -90
#define MAX_SPEED 90

int GetRGB(int source, int color)
{
	int OUT;
	unsigned int rawData[5] = {0};
	unsigned int normData[5] = {0};
	int scaledData[5] = {0};
	int cval;
	ReadSensorColorEx(source, cval, rawData, normData, scaledData);
	if (color == 1) OUT = (rawData[0]/10);
	if (color == 2) OUT = (rawData[1]/10);
	if (color == 3) OUT = (rawData[2]/10);
	if (color == 4) OUT = cval;
	return OUT;
}

bool Check_Green(int source)
{
	bool green_flag = false;
	unsigned int rawData[5] = {0};
	unsigned int normData[5] = {0};
	int scaledData[5] = {0};
	int cval;
	ReadSensorColorEx(source, cval, rawData, normData, scaledData);
	if(rawData[1] > rawData[2] && rawData[2] > rawData[0])
	{
		green_flag = true;
	}
	return green_flag;
}

int touch = 0;
int light_1 = 0, light_2 = 0, error = 0, origin_error = 0, foilS1 = 0, foilS2 = 0;
int speedB, speedC;

void Green()
{
    if(Check_Green(S1))
	{
		Off(OUT_ABC);
		//PlayTone(300, 300);
		Wait(1000);
		if(Check_Green(S1))
		{
			PlayTone(300, 200);
			Wait(1000);
			ClearScreen();
			Tank_turn_C(50, 90);
			Go_Fwd(50, 90);
		}
	}
	if(Check_Green(S2))
	{
		Off(OUT_ABC);
		//PlayTone(500, 300);
		Wait(1000);
		if(Check_Green(S2))
		{
			PlayTone(500, 200);
			Wait(1000);
			ClearScreen();
			Tank_turn_B(50, 90);
			Go_Fwd(50, 90);
		}
	}
}


void foil()
{
	if(GetRGB(S1, 1) > (0.95*foilS1) && GetRGB(S2, 1) > (0.95*foilS2))
	{
		Off(OUT_ABC);
		PlayTone(400, 1000);
		Wait(1500);
		Go_Fwd(30, 400);
		Tank_turn_C(30, 100);
		Go_Fwd(30, 720);
	}
}

task main()
{
	SetSensorTouch(S3);
	SetSensorColorFull(S1);
	SetSensorColorFull(S2);
	
	while(ButtonPressed(BTNCENTER, false) == 0)
	{
		light_1 = GetRGB(S1, 1);
		light_2 = GetRGB(S2, 1);
		origin_error = light_1 - light_2;
		TextOut(1, LCD_LINE1, "S1: "); NumOut(40, LCD_LINE1, light_1);
		TextOut(1, LCD_LINE2, "S2: "); NumOut(40, LCD_LINE2, light_2);
		Wait(50);
		ClearScreen();
	}
	Wait(500);
	
	while(ButtonPressed(BTNCENTER, false) == 0)
	{
		foilS1 = GetRGB(S1, 1);
		foilS2 = GetRGB(S2, 1);
		origin_error = light_1 - light_2;
		TextOut(1, LCD_LINE1, "FS1: "); NumOut(40, LCD_LINE1, foilS1);
		TextOut(1, LCD_LINE2, "FS2: "); NumOut(40, LCD_LINE2, foilS2);
		Wait(50);
		ClearScreen();
	}
	Wait(500);
	
	while(ButtonPressed(BTNCENTER, false) == 0)
	{
		TextOut(1, LCD_LINE1, "START");
		Wait(50);
		ClearScreen();
	}
	Wait(500);
	
	while (1)
	{
		foil();
		Green();
		if(SENSOR_4 == 1)
		{
			RotateMotor(OUT_BC, -30, 200);
			RotateMotorEx(OUT_BC, 30, 150, -100);
			RotateMotor(OUT_BC, 30, 720);
			RotateMotorEx(OUT_BC, 30, 300, 100);
			RotateMotor(OUT_BC, 30, 700);
		}
		
		light_1 = GetRGB(S1, 1) - origin_error;
		light_2 = GetRGB(S2, 1);
		
		error = light_1 - light_2;
		
		speedB = SPEED - (error * KP);
		speedC = SPEED + (error * KP);
		
		if(speedB < MIN_SPEED) speedB = MIN_SPEED;
		if(speedB > MAX_SPEED) speedB = MAX_SPEED;
		
		if(speedC < MIN_SPEED) speedC = MIN_SPEED;
		if(speedC > MAX_SPEED) speedC = MAX_SPEED;
		
		OnFwd(OUT_B, speedB);
		OnFwd(OUT_C, speedC);t
	}
}
